	/*
	 * '#': Alternate file name
	 * '%': Current file name
	 *		File name under the cursor
	 *		File name for autocommand
	 *	and following modifiers
	 */
	else
	{
	switch (spec_idx)
	{
	case SPEC_PERC:		/* '%': current file */
		if (curbuf->b_fname == NULL)
		{
			result = (char_u *)"";
			valid = 0;		/* Must have ":p:h" to be valid */
		}
		else
#ifdef RISCOS
			/* Always use the full path for RISC OS if possible. */
			result = curbuf->b_ffname;
			if (result == NULL)
			result = curbuf->b_fname;
#else
			result = curbuf->b_fname;
#endif
		break;

	case SPEC_HASH:		/* '#' or "#99": alternate file */
		if (src[1] == '#')  /* "##": the argument list */
		{
			result = arg_all();
			resultbuf = result;
			*usedlen = 2;
			if (escaped != NULL)
			*escaped = TRUE;
#ifdef FEAT_MODIFY_FNAME
			skip_mod = TRUE;
#endif
			break;
		}
		s = src + 1;
		i = (int)getdigits(&s);
		*usedlen = (int)(s - src); /* length of what we expand */

		buf = buflist_findnr(i);
		if (buf == NULL)
		{
			*errormsg = (char_u *)_("E194: No alternate file name to substitute for '#'");
			return NULL;
		}
		if (lnump != NULL)
			*lnump = ECMD_LAST;
		if (buf->b_fname == NULL)
		{
			result = (char_u *)"";
			valid = 0;		/* Must have ":p:h" to be valid */
		}
		else
			result = buf->b_fname;
		break;

#ifdef FEAT_SEARCHPATH
	case SPEC_CFILE:	/* file name under cursor */
		result = file_name_at_cursor(FNAME_MESS|FNAME_HYP, 1L, NULL);
		if (result == NULL)
		{
			*errormsg = (char_u *)"";
			return NULL;
		}
		resultbuf = result;		/* remember allocated string */
		break;
#endif

#ifdef FEAT_AUTOCMD
	case SPEC_AFILE:	/* file name for autocommand */
		result = autocmd_fname;
		if (result == NULL)
		{
			*errormsg = (char_u *)_("E495: no autocommand file name to substitute for \"<afile>\"");
			return NULL;
		}
		result = shorten_fname1(result);
		break;

	case SPEC_ABUF:		/* buffer number for autocommand */
		if (autocmd_bufnr <= 0)
		{
			*errormsg = (char_u *)_("E496: no autocommand buffer number to substitute for \"<abuf>\"");
			return NULL;
		}
		sprintf((char *)strbuf, "%d", autocmd_bufnr);
		result = strbuf;
		break;

	case SPEC_AMATCH:	/* match name for autocommand */
		result = autocmd_match;
		if (result == NULL)
		{
			*errormsg = (char_u *)_("E497: no autocommand match name to substitute for \"<amatch>\"");
			return NULL;
		}
		break;

#endif
	case SPEC_SFILE:	/* file name for ":so" command */
		result = sourcing_name;
		if (result == NULL)
		{
			*errormsg = (char_u *)_("E498: no :source file name to substitute for \"<sfile>\"");
			return NULL;
		}
		break;
#if defined(FEAT_CLIENTSERVER)
	case SPEC_CLIENT:	/* Source of last submitted input */
		sprintf((char *)strbuf, PRINTF_HEX_LONG_U,
							(long_u)clientWindow);
		result = strbuf;
		break;
#endif
	}

